<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_16</title>
</head>
<body>
    <h1>Capitulo 16</h1>
    <a>Ejercicio 26</a>

    <script>

        const calculadora = (expression) => {
            let tokens = expression.split('');
            let values = [];
            let ops = [];
  
            for (let i = 0; i < tokens.length; i++) {

                if (tokens[i] == ' ') {
                    continue;
                }
  
                if (tokens[i] >= '0' && tokens[i] <= '9') {
                    let sbuf = "";
                  
                    while (i < tokens.length && tokens[i] >= '0' && tokens[i] <= '9') {
                        sbuf = sbuf + tokens[i++];
                    }

                    values.push(parseInt(sbuf, 10));
                    i--;
                } else if (tokens[i] == '(') {
                    ops.push(tokens[i]);
                } else if (tokens[i] == ')') {
                    while (ops[ops.length - 1] != '(') {
                        values.push(applyOp(ops.pop(),values.pop(), values.pop()));
                    }
                    ops.pop();
                }  else if (tokens[i] == '+' || tokens[i] == '-' || tokens[i] == '*' || tokens[i] == '/') {

                    while (ops.length > 0 && hasPrecedence(tokens[i],ops[ops.length - 1])) {
                        values.push(applyOp(ops.pop(), values.pop(), values.pop()));
                    }
  
                    ops.push(tokens[i]);
                }
            }
  
            while (ops.length > 0) {
                values.push(applyOp(ops.pop(), values.pop(), values.pop()));
            }

            return values.pop();
        }

        const hasPrecedence = (op1, op2) => {

            if (op2 == '(' || op2 == ')') {
                return false;
            }

            if ((op1 == '*' || op1 == '/') && (op2 == '+' || op2 == '-')) {
                return false;
            } else {
                return true;
            }
        }
  
        const applyOp = (op, b, a) => {

            switch (op) {
                case '+':
                    return a + b;
                case '-':
                    return a - b;
                case '*':
                    return a * b;
                case '/':
                    if (b == 0) {
                    console.log("Cannot divide by zero");
                }
                return parseInt(a / b, 10);
            }
            return 0;
        }
    
        console.log(calculadora("2 * 3 + 5 / 6 * 3 + 15"));

</script>
    
</body>
</html>